# Compatibility

"""Provides code snipplets for ompatibility with older python versions.
"""

import sys


#-------------------------------------------------------------------------------
#
# sets module
#
#-------------------------------------------------------------------------------


try:
    import sets
except ImportError:
    import altsets as sets


#-------------------------------------------------------------------------------
#
# boolean values "True" and "False"
#
#-------------------------------------------------------------------------------

try:
    True, False
except NameError:
    True, False = (0==0, 0!=0)


#-------------------------------------------------------------------------------
#
# new style classes derived from "object"
#
#-------------------------------------------------------------------------------
    
try:
    object
except NameError:
    class object:
        pass


#-------------------------------------------------------------------------------
#
# define jython flag
#
#-------------------------------------------------------------------------------

try:
    import java
    jython = True
except:
    jython = False
    

#-------------------------------------------------------------------------------
#
# sum function
#
#-------------------------------------------------------------------------------

try:
    sum
except NameError:
    sum = lambda l: reduce(lambda a,b:a+b, l)

        
#-------------------------------------------------------------------------------
#
# numerical arrays 
#
#-------------------------------------------------------------------------------

import random, copy, math
try:
    from numarray import array
    HAS_NUMARRAY = True
except:
    try:
        from Numeric import array
        HAS_NUMARRAY = True
    except:
        from ArrayWrapper import array
        HAS_NUMARRAY = False

# patch for CoopSim only:
# from ArrayWrapper import array
# HAS_NUMARRAY = False


